jb_resource('material-demo','demos',[
  {
    "id": "baseline",
    "css": ".demo-basic {\n  padding: 0; }\n\n.demo-basic md-card-content {\n  padding: 16px; }\n\n.demo-full-width {\n  width: 100%; }\n\n.demo-icons {\n  font-size: 100%;\n  height: inherit;\n  vertical-align: top;\n  width: inherit; }\n\n.demo-card {\n  margin: 16px; }\n",
    "html": "<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Basic Forms</md-toolbar>\r\n  <md-card-content>\r\n    Text Before |\r\n    <md-checkbox>Checkbox Label</md-checkbox>\r\n    | Text 1 |\r\n    <md-radio-button value=\"option_1\">Radio 1</md-radio-button>\r\n    | Text 2 |\r\n    <md-radio-button value=\"option_2\">Radio 2</md-radio-button>\r\n    | Text 3 |\r\n    <md-radio-button value=\"option_3\">Radio 3</md-radio-button>\r\n    | Text 4 |\r\n    <md-input>Label</md-input>\r\n    | Text After\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Headers</md-toolbar>\r\n  <md-card-content>\r\n    <h1>\r\n      Text Before |\r\n      <md-checkbox>Checkbox Label</md-checkbox>\r\n      | Text 1 |\r\n      <md-radio-button value=\"option_1\">Radio 1</md-radio-button>\r\n      | Text 2 |\r\n      <md-radio-button value=\"option_2\">Radio 2</md-radio-button>\r\n      | Text 3 |\r\n      <md-radio-button value=\"option_3\">Radio 3</md-radio-button>\r\n      | Text 4 |\r\n      <md-input>Label</md-input>\r\n      | Text After\r\n    </h1>\r\n  </md-card-content>\r\n</md-card>\r\n"
  },
  {
    "id": "button",
    "css": ".demo-button button, .demo-button a {\n  margin: 8px;\n  text-transform: uppercase; }\n\n.demo-button section {\n  display: flex;\n  align-items: center;\n  background-color: #f7f7f7;\n  margin: 8px; }\n\n.demo-button p {\n  padding: 5px 15px; }\n",
    "html": "<div class=\"demo-button\">\r\n  <section>\r\n    <button md-button>flat</button>\r\n    <button md-raised-button>raised</button>\r\n    <button md-fab>\r\n      <md-icon class=\"md-24\">check</md-icon>\r\n    </button>\r\n    <button md-mini-fab>\r\n      <md-icon class=\"md-24\">check</md-icon>\r\n    </button>\r\n  </section>\r\n\r\n  <section>\r\n    <a href=\"http://www.google.com\" md-button color=\"primary\">SEARCH</a>\r\n    <a href=\"http://www.google.com\" md-raised-button>SEARCH</a>\r\n    <a href=\"http://www.google.com\" md-fab>\r\n      <md-icon class=\"md-24\">check</md-icon>\r\n    </a>\r\n    <a href=\"http://www.google.com\" md-mini-fab>\r\n      <md-icon class=\"md-24\">check</md-icon>\r\n    </a>\r\n  </section>\r\n\r\n  <section>\r\n    <button md-button color=\"primary\">primary</button>\r\n    <button md-button color=\"accent\">accent</button>\r\n    <button md-button color=\"warn\">warn</button>\r\n  </section>\r\n\r\n  <section>\r\n    <button md-raised-button color=\"primary\">primary</button>\r\n    <button md-raised-button color=\"accent\">accent</button>\r\n    <button md-raised-button color=\"warn\">warn</button>\r\n  </section>\r\n\r\n  <section>\r\n    <button md-fab color=\"primary\">\r\n      <md-icon class=\"md-24\">home</md-icon>\r\n    </button>\r\n    <button md-fab color=\"accent\">\r\n      <md-icon class=\"md-24\">favorite</md-icon>\r\n    </button>\r\n    <button md-fab color=\"warn\">\r\n      <md-icon class=\"md-24\">feedback</md-icon>\r\n    </button>\r\n  </section>\r\n\r\n  <section>\r\n    <button md-icon-button color=\"primary\">\r\n      <md-icon class=\"md-24\">menu</md-icon>\r\n    </button>\r\n\r\n    <button md-icon-button color=\"accent\">\r\n      <md-icon class=\"md-24\">favorite</md-icon>\r\n    </button>\r\n\r\n    <button md-icon-button>\r\n      <md-icon class=\"md-24\">more_vert</md-icon>\r\n    </button>\r\n  </section>\r\n\r\n  <section>\r\n    <div>\r\n      <p>isDisabled: {{isDisabled}}, clickCounter: <span>{{clickCounter}}</span></p>\r\n      <button md-raised-button (click)=\"isDisabled=!isDisabled\">\r\n        Disable buttons\r\n      </button>\r\n      <button md-raised-button (click)=\"button1.focus()\">Focus 1</button>\r\n      <button md-raised-button (click)=\"button2.focus()\">Focus 2</button>\r\n      <button md-raised-button (click)=\"button3.focus()\">Focus 3</button>\r\n    </div>\r\n    <button md-button #button1 [disabled]=\"isDisabled\" (click)=\"clickCounter=clickCounter+1\">off</button>\r\n    <button md-button color=\"primary\" [disabled]=\"isDisabled\">off</button>\r\n    <a href=\"http://www.google.com\" #button2 md-button color=\"accent\">off</a>\r\n    <button md-raised-button #button3 color=\"primary\" [disabled]=\"isDisabled\">off</button>\r\n    <button md-mini-fab [disabled]=\"isDisabled\">\r\n      <md-icon class=\"md-24\">check</md-icon>\r\n    </button>\r\n\r\n    <button md-icon-button color=\"accent\" [disabled]=\"isDisabled\">\r\n      <md-icon class=\"md-24\">favorite</md-icon>\r\n    </button>\r\n  </section>\r\n  <section>\r\n    <a href=\"http://www.google.com\" md-button color=\"primary\">SEARCH</a>\r\n    <button md-button>DANCE</button>\r\n  </section>\r\n  <section>\r\n    <a href=\"http://www.google.com\" md-raised-button color=\"primary\">SEARCH</a>\r\n    <button md-raised-button>DANCE</button>\r\n  </section>\r\n</div>\r\n"
  },
  {
    "id": "card",
    "css": ".demo-card-container {\n  display: flex;\n  flex-flow: column nowrap; }\n  .demo-card-container md-card {\n    margin: 0 16px 16px 0;\n    width: 350px; }\n  .demo-card-container img {\n    background-color: gray; }\n\n.demo-card-blue {\n  background-color: #b0becc; }\n  .demo-card-blue md-card-actions {\n    display: flex;\n    flex-direction: column; }\n",
    "html": "<div class=\"demo-card-container\">\r\n  <md-card>\r\n    Hello\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title-group>\r\n        <md-card-title>Card with title</md-card-title>\r\n        <md-card-subtitle>Subtitle</md-card-subtitle>\r\n        <img md-card-md-image>\r\n    </md-card-title-group>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-subtitle>Subtitle</md-card-subtitle>\r\n    <md-card-title>Card with title and footer</md-card-title>\r\n    <md-card-content>\r\n      <p>This is supporting text.</p>\r\n      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>\r\n    </md-card-content>\r\n    <md-card-actions>\r\n      <button md-button>LIKE</button>\r\n      <button md-button>SHARE</button>\r\n    </md-card-actions>\r\n    <md-card-footer>\r\n      <md-progress-bar mode=\"indeterminate\"></md-progress-bar>\r\n    </md-card-footer>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <img md-card-image src=\"https://material.angularjs.org/latest/img/washedout.png\">\r\n    <md-card-title>Content Title</md-card-title>\r\n    <md-card-content>\r\n      <p>Here is some content</p>\r\n    </md-card-content>\r\n    <md-card-actions align=\"end\">\r\n      <button md-button>LIKE</button>\r\n      <button md-button>SHARE</button>\r\n    </md-card-actions>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-header>\r\n      <img md-card-avatar>\r\n      <md-card-title>Header title</md-card-title>\r\n      <md-card-subtitle>Header subtitle</md-card-subtitle>\r\n    </md-card-header>\r\n    <img md-card-image src=\"https://material.angularjs.org/latest/img/washedout.png\">\r\n    <md-card-content>\r\n      <p>Here is some content</p>\r\n    </md-card-content>\r\n  </md-card>\r\n\r\n  <md-card class=\"demo-card-blue md-card-flat\">\r\n    <md-card-title>Easily customizable</md-card-title>\r\n    <md-card-actions>\r\n      <button md-button>First</button>\r\n      <button md-button>Second</button>\r\n    </md-card-actions>\r\n  </md-card>\r\n</div>\r\n"
  },
  {
    "id": "checkbox",
    "css": ".demo-checkboxes {\n  margin: 8px 0; }\n",
    "html": "<h1>md-checkbox: Basic Example</h1>\r\n<form>\r\n<md-checkbox [(ngModel)]=\"isChecked\"\r\n              name=\"cb\"\r\n             (change)=\"isIndeterminate = false\"\r\n             [indeterminate]=\"isIndeterminate\"\r\n             [disabled]=\"isDisabled\"\r\n             [align]=\"alignment\">\r\n  Do you want to <em>foobar</em> the <em>bazquux</em>?\r\n\r\n</md-checkbox> - <strong>{{printResult()}}</strong>\r\n</form>\r\n<div class=\"demo-checkboxes\">\r\n<input id=\"indeterminate-toggle\"\r\n       type=\"checkbox\"\r\n       [(ngModel)]=\"isIndeterminate\"\r\n       [disabled]=\"isDisabled\">\r\n<label for=\"indeterminate-toggle\">Toggle Indeterminate</label>\r\n<input id=\"disabled-toggle\" type=\"checkbox\" [(ngModel)]=\"isDisabled\">\r\n<label for=\"disabled-toggle\">Toggle Disabled</label>\r\n</div>\r\n<div>\r\n  <p>Alignment:</p>\r\n  <div>\r\n    <input #start type=\"radio\"\r\n                  value=\"start\"\r\n                  id=\"align-start\"\r\n                  name=\"alignment\"\r\n                  (click)=\"alignment = start.value\"\r\n                  checked>\r\n    <label for=\"align-start\">Start</label>\r\n  </div>\r\n  <div>\r\n    <input #end type=\"radio\"\r\n                  value=\"end\"\r\n                  id=\"align-end\"\r\n                  name=\"alignment\"\r\n                  (click)=\"alignment = end.value\">\r\n    <label for=\"align-end\">End</label>\r\n  </div>\r\n</div>\r\n\r\n<h1>Nested Checklist</h1>\r\n<md-checkbox-demo-nested-checklist></md-checkbox-demo-nested-checklist>"
  },
  // {
  //   "id": "dialog",
  //   "css": ".demo-dialog {\n  color: rebeccapurple; }\n",
  //   "html": "<h1>Dialog demo</h1>\r\n\r\n<button (click)=\"open()\" [disabled]=\"dialogRef\">Open dialog</button>\r\n\r\n<p>\r\n  Last close result: {{lastCloseResult}}\r\n</p>\r\n"
  // },
  {
    "id": "gestures",
    "css": ".demo-gestures div {\n  height: 100px;\n  width: 200px;\n  background: gray;\n  padding: 15px;\n  color: white; }\n",
    "html": "<div class=\"demo-gestures\">\r\n    <div (drag)=\"dragCount = dragCount + 1\" (pan)=\"panCount = panCount + 1\"\r\n         (longpress)=\"longpressCount = longpressCount + 1\" (press)=\"pressCount = pressCount + 1\"\r\n         (swipe)=\"swipeCount = swipeCount + 1\" (slide)=\"slideCount = slideCount + 1\">\r\n        Drag, swipe, or press me.\r\n    </div>\r\n    <p>Drag: {{dragCount}}</p>\r\n    <p>Pan: {{panCount}}</p>\r\n    <p>Longpress: {{longpressCount}}</p>\r\n    <p>Press: {{pressCount}}</p>\r\n    <p>Swipe: {{swipeCount}}</p>\r\n    <p>Slide: {{slideCount}}</p>\r\n</div>\r\n"
  },
  {
    "id": "gridlist",
    "css": ".demo-grid-list {\n  width: 1100px; }\n  .demo-grid-list md-card {\n    margin: 16px 0; }\n  .demo-grid-list p {\n    margin: 16px; }\n  .demo-grid-list .demo-basic-list md-grid-tile {\n    background: rgba(0, 0, 0, 0.32); }\n  .demo-grid-list img {\n    width: 350px; }\n",
    "html": "<div class=\"demo-grid-list\">\r\n  <md-card>\r\n    <md-card-title>Basic grid list</md-card-title>\r\n    <md-card-content class=\"demo-basic-list\">\r\n      <md-grid-list cols=\"4\" [rowHeight]=\"basicRowHeight\">\r\n        <md-grid-tile> One </md-grid-tile>\r\n        <md-grid-tile> Two </md-grid-tile>\r\n        <md-grid-tile> Three </md-grid-tile>\r\n        <md-grid-tile> Four </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title>Fixed-height grid list</md-card-title>\r\n    <md-card-content>\r\n      <md-grid-list [cols]=\"fixedCols\" [rowHeight]=\"fixedRowHeight\">\r\n        <md-grid-tile *ngFor=\"let tile of tiles\" [colspan]=\"tile.cols\" [rowspan]=\"tile.rows\"\r\n                      [style.background]=\"tile.color\">\r\n          {{tile.text}}\r\n        </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n    <md-card-actions>\r\n      <p>Change list cols: <input type=\"number\" [(ngModel)]=\"fixedCols\"></p>\r\n      <p>Change row height: <input type=\"number\" [(ngModel)]=\"fixedRowHeight\"></p>\r\n      <button md-button (click)=\"addTileCols()\" color=\"primary\">ADD COLSPAN (THREE)</button>\r\n    </md-card-actions>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title>Ratio-height grid list</md-card-title>\r\n    <md-card-content class=\"demo-ratio-list\">\r\n      <md-grid-list cols=\"2\" [rowHeight]=\"ratio\" gutterSize=\"4px\">\r\n        <md-grid-tile *ngFor=\"let tile of tiles\" [style.background]=\"'lightblue'\">\r\n          {{tile.text}}\r\n        </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n    <md-card-actions>\r\n      <p>Change ratio: <input [(ngModel)]=\"ratio\"></p>\r\n    </md-card-actions>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title>Fit-height grid list</md-card-title>\r\n    <md-card-content class=\"demo-fit-list\">\r\n      <md-grid-list cols=\"2\" rowHeight=\"fit\" [gutterSize]=\"ratioGutter\"\r\n                    [style.height]=\"fitListHeight\">\r\n        <md-grid-tile *ngFor=\"let tile of tiles\" [style.background]=\"'#F1EBBA'\">\r\n          {{tile.text}}\r\n        </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n    <md-card-actions>\r\n      <p>Change list height: <input [(ngModel)]=\"fitListHeight\"></p>\r\n      <p>Change gutter: <input type=\"number\" [(ngModel)]=\"ratioGutter\"></p>\r\n    </md-card-actions>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title>Grid list with header</md-card-title>\r\n    <md-card-content>\r\n      <md-grid-list cols=\"3\" rowHeight=\"200px\">\r\n        <md-grid-tile *ngFor=\"let dog of dogs\" style=\"background:gray\">\r\n          <md-grid-tile-header>\r\n            <md-icon md-grid-avatar>info_outline</md-icon>\r\n            {{dog.name}}\r\n          </md-grid-tile-header>\r\n        </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n  </md-card>\r\n\r\n  <md-card>\r\n    <md-card-title>Grid list with footer</md-card-title>\r\n    <md-card-content>\r\n      <md-grid-list cols=\"3\" rowHeight=\"200px\">\r\n        <md-grid-tile *ngFor=\"let dog of dogs\">\r\n          <img [alt]=\"dog.name\" src=\"https://material.angularjs.org/material2_assets/ngconf/{{dog.name}}.png\">\r\n          <md-grid-tile-footer>\r\n            <h3 md-line>{{dog.name}}</h3>\r\n            <span md-line>Human: {{dog.human}}</span>\r\n            <md-icon>star_border</md-icon>\r\n          </md-grid-tile-footer>\r\n        </md-grid-tile>\r\n      </md-grid-list>\r\n    </md-card-content>\r\n  </md-card>\r\n</div>\r\n\r\n"
  },
  {
    "id": "icon",
    "css": ".demo-icon md-icon {\n  color: purple; }\n\n.demo-icon md-icon.green {\n  color: green; }\n",
    "html": "<div class=\"demo-icon\">\r\n  <p>\r\n    These are some icons.\r\n  </p>\r\n\r\n  <p>\r\n    From URL:\r\n    <md-icon svgSrc=\"/icon/assets/search-icon.svg\"></md-icon>\r\n  </p>\r\n\r\n  <p>\r\n    By name registered with MdIconProvider:\r\n    <md-icon svgIcon=\"thumb-up\" class=\"green\"></md-icon>\r\n    <md-icon svgIcon=\"thumb-up\"></md-icon>\r\n  </p>\r\n\r\n  <p>\r\n    From icon set:\r\n    <md-icon svgIcon=\"core:alarm\"></md-icon>\r\n    <md-icon svgIcon=\"core:accessibility\"></md-icon>\r\n    <md-icon svgIcon=\"core:alarm\"></md-icon>\r\n  </p>\r\n\r\n  <p>\r\n    Ligature from Material Icons font:\r\n    <md-icon>home</md-icon>\r\n  </p>\r\n\r\n  <p>\r\n    Custom icon font and CSS:\r\n    <md-icon fontSet=\"fontawesome\" fontIcon=\"fa-birthday-cake\"></md-icon>\r\n  </p>\r\n</div>"
  },
  {
    "id": "input",
    "css": ".demo-basic {\n  padding: 0; }\n\n.demo-basic md-card-content {\n  padding: 16px; }\n\n.demo-full-width {\n  width: 100%; }\n\n.demo-icons {\n  font-size: 100%;\n  height: inherit;\n  vertical-align: top;\n  width: inherit; }\n\n.demo-card {\n  margin: 16px; }\n",
    "html": "<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Basic</md-toolbar>\r\n  <md-card-content>\r\n    <form>\r\n      <md-input class=\"demo-full-width\" placeholder=\"Company (disabled)\" disabled value=\"Google\">\r\n      </md-input>\r\n\r\n      <table style=\"width: 100%\" cellspacing=\"0\"><tr>\r\n        <td><md-input placeholder=\"First name\" style=\"width: 100%\"></md-input></td>\r\n        <td><md-input placeholder=\"Long Last Name That Will Be Truncated\" style=\"width: 100%\"></md-input></td>\r\n      </tr></table>\r\n      <p>\r\n        <md-input class=\"demo-full-width\" placeholder=\"Address\" value=\"1600 Amphitheatre Pkway\"></md-input>\r\n        <md-input class=\"demo-full-width\" placeholder=\"Address 2\"></md-input>\r\n      </p>\r\n      <table style=\"width: 100%\" cellspacing=\"0\"><tr>\r\n        <td><md-input class=\"demo-full-width\" placeholder=\"City\" value=\"Mountain View\"></md-input></td>\r\n        <td><md-input class=\"demo-full-width\" placeholder=\"State\" maxLength=\"2\" value=\"CA\"></md-input></td>\r\n        <td><md-input #postalCode class=\"demo-full-width\" maxLength=\"5\"\r\n                      placeholder=\"Postal Code\"\r\n                      value=\"94043\">\r\n          <md-hint align=\"end\"></md-hint>\r\n        </md-input></td>\r\n      </tr></table>\r\n    </form>\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Prefix + Suffix</md-toolbar>\r\n  <md-card-content>\r\n    <md-input placeholder=\"amount\" align=\"end\">\r\n      <span md-prefix>$&nbsp;</span>\r\n      <span md-suffix>.00</span>\r\n    </md-input>\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Divider Colors</md-toolbar>\r\n  <md-card-content>\r\n    <md-input dividerColor=\"primary\" placeholder=\"Default Color\" value=\"example\"></md-input>\r\n    <md-input dividerColor=\"accent\" placeholder=\"Accent Color\" value=\"example\"></md-input>\r\n    <md-input dividerColor=\"warn\" placeholder=\"Warn Color\" value=\"example\"></md-input>\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card demo-basic\">\r\n  <md-toolbar color=\"primary\">Hints</md-toolbar>\r\n  <md-card-content>\r\n    <p>\r\n      <md-input placeholder=\"Character count (100 max)\" maxLength=\"100\" class=\"demo-full-width\"\r\n                value=\"Hello world. How are you?\"\r\n                #characterCountHintExample>\r\n        <md-hint align=\"end\"></md-hint>\r\n      </md-input>\r\n    </p>\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card\">\r\n  <md-card-title>\r\n    Hello <md-input [(ngModel)]=\"name\" type=\"text\" placeholder=\"First name\"></md-input>,\r\n    how are you?\r\n  </md-card-title>\r\n  <md-card-content>\r\n    <p>\r\n      <md-input disabled placeholder=\"Disabled field\" value=\"Value\"></md-input>\r\n      <md-input required placeholder=\"Required field\"></md-input>\r\n    </p>\r\n    <p>\r\n      <md-input placeholder=\"100% width placeholder\" style=\"width: 100%\"></md-input>\r\n    </p>\r\n    <p>\r\n      <md-input placeholder=\"Character count (100 max)\" maxLength=\"100\" style=\"width: 100%\"\r\n                #input>\r\n        <md-hint align=\"end\"></md-hint>\r\n      </md-input>\r\n    </p>\r\n    <p>\r\n      <md-input placeholder=\"Show Hint Label\" style=\"width: 100%\"\r\n                hintLabel=\"Hint label\"></md-input>\r\n    </p>\r\n\r\n    <p>\r\n      <md-input>\r\n        <md-placeholder>\r\n          I <md-icon class=\"demo-icons\">favorite</md-icon> <b>bold</b> placeholder\r\n        </md-placeholder>\r\n        <md-hint>\r\n          I also <md-icon class=\"demo-icons\">home</md-icon> <i>italic</i> hint labels\r\n        </md-hint>\r\n      </md-input>\r\n    </p>\r\n    <p>\r\n      <md-input placeholder=\"Show Hint Label With Character Count\" style=\"width: 100%\"\r\n                hintLabel=\"Hint label\" characterCounter></md-input>\r\n    </p>\r\n    <p>\r\n      <md-checkbox [(ngModel)]=\"dividerColor\">Check to change the divider color:</md-checkbox>\r\n      <md-input [dividerColor]=\"dividerColor ? 'primary' : 'accent'\"\r\n                [placeholder]=\"dividerColor ? 'Primary color' : 'Accent color'\"></md-input>\r\n    </p>\r\n    <p>\r\n      <md-checkbox [(ngModel)]=\"requiredField\"> Check to make required:</md-checkbox>\r\n      <md-input [required]=\"requiredField\"\r\n                [placeholder]=\"requiredField ? 'Required field' : 'Not required field'\"></md-input>\r\n    </p>\r\n    <p>\r\n      <md-checkbox [(ngModel)]=\"floatingLabel\"> Check to make floating label:</md-checkbox>\r\n      <md-input [floatingPlaceholder]=\"floatingLabel\"\r\n                [placeholder]=\"floatingLabel ? 'Floating label' : 'Not floating label'\"></md-input>\r\n    </p>\r\n\r\n    <p>\r\n      <md-input placeholder=\"Prefixed\" value=\"example\">\r\n        <div md-prefix>Example:&nbsp;</div>\r\n      </md-input>\r\n      <md-input placeholder=\"Suffixed\" value=\"123\" align=\"end\">\r\n        <span md-suffix>.00 €</span>\r\n      </md-input>\r\n      <br/>\r\n      Both:\r\n      <md-input #email placeholder=\"Email Address\" value=\"angular-core\" align=\"end\">\r\n        <span md-prefix><md-icon [class.primary]=\"email.focused\" class=\"demo-icons demo-transform\">email</md-icon>&nbsp;</span>\r\n        <span md-suffix class=\"demo-transform\" [class.primary]=\"email.focused\">&nbsp;@gmail.com</span>\r\n      </md-input>\r\n    </p>\r\n\r\n    <p>\r\n      Empty: <md-input></md-input>\r\n      <label>Label: <md-input></md-input></label>\r\n    </p>\r\n  </md-card-content>\r\n</md-card>\r\n\r\n<md-card class=\"demo-card\">\r\n  <table width=\"100%\">\r\n    <thead>\r\n      <td>Table</td>\r\n      <td colspan=\"3\">\r\n        <button (click)=\"addABunch(5)\">Add 5</button>\r\n        <button (click)=\"addABunch(10)\">Add 10</button>\r\n        <button (click)=\"addABunch(100)\">Add 100</button>\r\n        <button (click)=\"addABunch(1000)\">Add 1000</button>\r\n      </td>\r\n    </thead>\r\n    <tr *ngFor=\"let item of items; let i = index\">\r\n      <td>{{i+1}}</td>\r\n      <td>\r\n        <md-input type=\"number\" placeholder=\"value\" aria-label=\"hello\" [(ngModel)]=\"items[i].value\"></md-input>\r\n      </td>\r\n      <td>\r\n        <input type=\"number\" [(ngModel)]=\"items[i].value\">\r\n      </td>\r\n      <td>{{item.value}}</td>\r\n    </tr>\r\n  </table>\r\n</md-card>\r\n"
  },
  {
    "id": "list",
    "css": ".demo {\n  display: flex;\n  flex-flow: row wrap; }\n  .demo md-list, .demo md-nav-list {\n    border: 1px solid rgba(0, 0, 0, 0.12);\n    width: 350px;\n    margin: 20px 20px 0 0; }\n  .demo h2 {\n    margin-top: 20px; }\n  .demo md-icon {\n    color: rgba(0, 0, 0, 0.12); }\n  .demo [md-list-icon] {\n    color: white;\n    background: rgba(0, 0, 0, 0.3); }\n\n.demo-secondary-text {\n  color: rgba(0, 0, 0, 0.54); }\n",
    "html": "\r\n<h1>md-list demo</h1>\r\n\r\n<button md-raised-button (click)=\"thirdLine=!thirdLine\" class=\"demo-button\">Show third line</button>\r\n\r\n<div class=\"demo\">\r\n  <div>\r\n    <h2>Normal lists</h2>\r\n\r\n    <md-list>\r\n      <h3 md-subheader>Items</h3>\r\n      <md-list-item *ngFor=\"let item of items\">\r\n        {{item}}\r\n      </md-list-item>\r\n    </md-list>\r\n\r\n    <md-list>\r\n      <md-list-item *ngFor=\"let contact of contacts\">\r\n        <h3 md-line>{{contact.name}}</h3>\r\n        <p md-line *ngIf=\"thirdLine\">extra line</p>\r\n        <p md-line class=\"demo-secondary-text\">{{contact.headline}}</p>\r\n      </md-list-item>\r\n    </md-list>\r\n\r\n    <md-list>\r\n      <h3 md-subheader>Today</h3>\r\n      <md-list-item *ngFor=\"let message of messages\">\r\n        <img md-list-avatar [src]=\"message.image\" alt=\"Image of {{message.from}}\">\r\n        <h4 md-line>{{message.from}}</h4>\r\n        <p md-line>\r\n          <span>{{message.subject}} -- </span>\r\n          <span class=\"demo-secondary-text\">{{message.message}}</span>\r\n        </p>\r\n      </md-list-item>\r\n      <md-divider></md-divider>\r\n      <md-list-item *ngFor=\"let message of messages\">\r\n        <h4 md-line>{{message.from}}</h4>\r\n        <p md-line> {{message.subject}} </p>\r\n        <p md-line class=\"demo-secondary-text\">{{message.message}} </p>\r\n      </md-list-item>\r\n    </md-list>\r\n  </div>\r\n\r\n  <div>\r\n    <h2>Dense lists</h2>\r\n    <md-list dense>\r\n      <h3 md-subheader>Items</h3>\r\n      <md-list-item *ngFor=\"let item of items\">\r\n        {{item}}\r\n      </md-list-item>\r\n    </md-list>\r\n\r\n    <md-list dense>\r\n      <md-list-item *ngFor=\"let contact of contacts\">\r\n        <h3 md-line>{{contact.name}}</h3>\r\n        <p md-line class=\"demo-secondary-text\">{{contact.headline}}</p>\r\n      </md-list-item>\r\n    </md-list>\r\n\r\n    <md-list dense>\r\n      <h3 md-subheader>Today</h3>\r\n      <md-list-item *ngFor=\"let message of messages\">\r\n        <img md-list-avatar [src]=\"message.image\" alt=\"Image of {{message.from}}\">\r\n        <h4 md-line>{{message.from}}</h4>\r\n        <p md-line> {{message.subject}} </p>\r\n        <p md-line class=\"demo-secondary-text\">{{message.message}} </p>\r\n      </md-list-item>\r\n    </md-list>\r\n  </div>\r\n  <div>\r\n    <h2>Nav lists</h2>\r\n    <md-nav-list>\r\n      <a md-list-item *ngFor=\"let link of links\" href=\"http://www.google.com\">\r\n        {{ link.name }}\r\n      </a>\r\n    </md-nav-list>\r\n    <div *ngIf=\"infoClicked\">\r\n      More info!\r\n    </div>\r\n    <md-nav-list>\r\n      <md-list-item *ngFor=\"let link of links\">\r\n        <a md-line href=\"http://www.google.com\">{{ link.name }}</a>\r\n        <button md-icon-button (click)=\"infoClicked=!infoClicked\">\r\n          <md-icon>info</md-icon>\r\n        </button>\r\n      </md-list-item>\r\n    </md-nav-list>\r\n    <md-nav-list>\r\n      <a md-list-item *ngFor=\"let link of links\" href=\"http://www.google.com\">\r\n        <md-icon md-list-icon>folder</md-icon>\r\n        <span md-line>{{ link.name }}</span>\r\n        <span md-line class=\"demo-secondary-text\"> Description </span>\r\n      </a>\r\n    </md-nav-list>\r\n    <md-nav-list dense>\r\n      <md-list-item *ngFor=\"let link of links\">\r\n        <a md-line href=\"http://www.google.com\">{{ link.name }}</a>\r\n        <button md-icon-button (click)=\"infoClicked=!infoClicked\">\r\n          <md-icon class=\"material-icons\">info</md-icon>\r\n        </button>\r\n      </md-list-item>\r\n    </md-nav-list>\r\n  </div>\r\n</div>\r\n"
  },
  // {
  //   "id": "menu",
  //   "css": ".demo-menu {\n  display: flex;\n  flex-flow: row wrap; }\n  .demo-menu .menu-section {\n    width: 300px;\n    margin: 20px; }\n  .demo-menu .end-icon {\n    align-items: flex-end; }\n",
  //   "html": "<div class=\"demo-menu\">\r\n  <div class=\"menu-section\">\r\n    <p>You clicked on: {{ selected }}</p>\r\n\r\n    <md-toolbar>\r\n      <button md-icon-button [md-menu-trigger-for]=\"menu\">\r\n        <md-icon>more_vert</md-icon>\r\n      </button>\r\n    </md-toolbar>\r\n\r\n    <md-menu #menu=\"mdMenu\">\r\n      <button md-menu-item *ngFor=\"let item of items\" (click)=\"select(item.text)\" [disabled]=\"item.disabled\">\r\n        {{ item.text }}\r\n      </button>\r\n    </md-menu>\r\n  </div>\r\n  <div class=\"menu-section\">\r\n    <p> Clicking these will navigate:</p>\r\n    <md-toolbar>\r\n      <button md-icon-button [md-menu-trigger-for]=\"anchorMenu\">\r\n        <md-icon>more_vert</md-icon>\r\n      </button>\r\n    </md-toolbar>\r\n\r\n    <md-menu #anchorMenu=\"mdMenu\">\r\n      <a md-menu-item *ngFor=\"let item of items\" href=\"http://www.google.com\" [disabled]=\"item.disabled\">\r\n        {{ item.text }}\r\n      </a>\r\n    </md-menu>\r\n  </div>\r\n  <div class=\"menu-section\">\r\n    <p>\r\n      Position x: before\r\n    </p>\r\n    <md-toolbar class=\"end-icon\">\r\n      <button md-icon-button [md-menu-trigger-for]=\"posXMenu\">\r\n        <md-icon>more_vert</md-icon>\r\n      </button>\r\n    </md-toolbar>\r\n\r\n    <md-menu x-position=\"before\" #posXMenu=\"mdMenu\" class=\"before\">\r\n      <button md-menu-item *ngFor=\"let item of items\" [disabled]=\"item.disabled\">\r\n        {{ item.text }}\r\n      </button>\r\n    </md-menu>\r\n  </div>\r\n  <div class=\"menu-section\">\r\n    <p>\r\n      Position y: above\r\n    </p>\r\n    <md-toolbar>\r\n      <button md-icon-button [md-menu-trigger-for]=\"posYMenu\">\r\n        <md-icon>more_vert</md-icon>\r\n      </button>\r\n    </md-toolbar>\r\n\r\n    <md-menu y-position=\"above\" #posYMenu=\"mdMenu\">\r\n      <button md-menu-item *ngFor=\"let item of items\" [disabled]=\"item.disabled\">\r\n        {{ item.text }}\r\n      </button>\r\n    </md-menu>\r\n  </div>\r\n</div>\r\n"
  // },
  // {
  //   "id": "overlay",
  //   "css": ".demo-rotini {\n  padding: 10px;\n  border: 1px solid black;\n  background-color: skyblue; }\n\n.demo-fusilli {\n  padding: 10px;\n  border: 1px solid black;\n  background-color: lightgoldenrodyellow; }\n\n.demo-spagetti {\n  margin: 0;\n  padding: 10px;\n  border: 1px solid black;\n  color: white;\n  background-color: rebeccapurple;\n  opacity: 0.5; }\n",
  //   "html": "<button (click)=\"openRotiniPanel()\">\r\n  Pasta 1\r\n</button>\r\n\r\n<button (click)=\"openFusilliPanel()\">\r\n  Pasta 2\r\n</button>\r\n\r\n<button overlay-origin (click)=\"openSpaghettiPanel()\">\r\n  Pasta 3\r\n</button>\r\n\r\n\r\n<button overlay-origin #trigger=\"overlayOrigin\" (click)=\"isMenuOpen = !isMenuOpen\">\r\n  Open menu\r\n</button>\r\n\r\n<template connected-overlay [origin]=\"trigger\">\r\n  <div style=\"background-color: mediumpurple\" *ngIf=\"isMenuOpen\">\r\n    This is the menu panel.\r\n  </div>\r\n</template>\r\n\r\n<!-- Template to load into an overlay. -->\r\n<template portal>\r\n  <p class=\"demo-fusilli\"> Fusilli </p>\r\n</template>\r\n"
  // },
  // {
  //   "id": "portal",
  //   "css": ".demo-portal-host {\n  margin-bottom: 10px;\n  padding: 10px;\n  border: 1px dashed black;\n  width: 500px;\n  height: 100px; }\n",
  //   "html": "<h2> The portal host is here: </h2>\r\n<div class=\"demo-portal-host\">\r\n  <template [portalHost]=\"selectedPortal\"></template>\r\n</div>\r\n\r\n<button type=\"button\" (click)=\"selectedPortal = programmingJoke\">\r\n  Programming joke\r\n</button>\r\n\r\n<button type=\"button\" (click)=\"selectedPortal = mathJoke\">\r\n  Math joke\r\n</button>\r\n\r\n<button type=\"button\" (click)=\"selectedPortal = scienceJoke\">\r\n  Science joke\r\n</button>\r\n\r\n<!-- Template vars on <template> elements can't be accessed _in_ the template because Angular\r\n    doesn't support grabbing the instance / TemplateRef this way because the variable may be\r\n    referring to something *in* the template (such as #item in ngFor). As such, the component\r\n    has to use @ViewChild / @ViewChildren to get these references.\r\n    See https://github.com/angular/angular/issues/7158 -->\r\n<template portal>\r\n  <p> - Why don't jokes work in octal?</p>\r\n  <p> - Because 7 10 11.</p>\r\n</template>\r\n\r\n<div *portal>\r\n <p> - Did you hear about this year's Fibonacci Conference? </p>\r\n <p> - It's going to be as the last two put together. </p>\r\n</div>\r\n"
  // },
  {
    "id": "progressBar",
    "css": ".demo-progress-bar-container {\n  width: 100%; }\n\n.demo-progress-bar-margins {\n  margin: 20px 0; }\n\n.demo-progress-bar-spacer {\n  display: inline-block;\n  width: 50px; }\n",
    "html": "<h1>Determinate</h1>\r\n<div class=\"demo-progress-bar-container\">\r\n  <md-progress-bar mode=\"determinate\"\r\n                   [value]=\"determinateProgressValue\"\r\n                   color=\"primary\"\r\n                   class=\"demo-progress-bar-margins\"></md-progress-bar>\r\n</div>\r\n<span>Value: {{determinateProgressValue}}</span>\r\n<button md-raised-button (click)=\"stepDeterminateProgressVal(10)\">Increase</button>\r\n<button md-raised-button (click)=\"stepDeterminateProgressVal(-10)\">Decrease</button>\r\n<h1>Buffer</h1>\r\n<div class=\"demo-progress-bar-container\">\r\n  <md-progress-bar [value]=\"bufferProgressValue\"\r\n                   [bufferValue]=\"bufferBufferValue\"\r\n                   mode=\"buffer\"\r\n                   color=\"warn\"\r\n                   class=\"demo-progress-bar-margins\"></md-progress-bar>\r\n</div>\r\n<span>Value: {{bufferProgressValue}}</span>\r\n<button md-raised-button (click)=\"stepBufferProgressVal(10)\">Increase</button>\r\n<button md-raised-button (click)=\"stepBufferProgressVal(-10)\">Decrease</button>\r\n<span class=\"demo-progress-bar-spacer\"></span>\r\n<span>Buffer Value: {{bufferBufferValue}}</span>\r\n<button md-raised-button (click)=\"stepBufferBufferVal(10)\">Increase</button>\r\n<button md-raised-button (click)=\"stepBufferBufferVal(-10)\">Decrease</button>\r\n\r\n<h1>Indeterminate</h1>\r\n<div class=\"demo-progress-bar-container\">\r\n  <md-progress-bar mode=\"indeterminate\"\r\n                   class=\"demo-progress-bar-margins\"></md-progress-bar>\r\n</div>\r\n\r\n<h1>Query</h1>\r\n<div class=\"demo-progress-bar-container\">\r\n  <md-progress-bar mode=\"query\"\r\n                   class=\"demo-progress-bar-margins\"></md-progress-bar>\r\n</div>\r\n"
  },
  {
    "id": "progressCircle",
    "css": ".demo-progress-circle {\n  width: 100%; }\n  .demo-progress-circle md-progress-circle,\n  .demo-progress-circle md-spinner {\n    display: inline-block; }\n",
    "html": "<h1>Determinate</h1>\r\n<div class=\"demo-progress-circle\">\r\n  <md-progress-circle mode=\"determinate\"\r\n                      [value]=\"progressValue\"\r\n                      class=\"md-primary\"></md-progress-circle>\r\n  <md-progress-circle [value]=\"progressValue\"\r\n                      color=\"accent\"></md-progress-circle>\r\n</div>\r\n<span>Value: {{progressValue}}</span>\r\n<button md-raised-button (click)=\"step(10)\">Increase</button>\r\n<button md-raised-button (click)=\"step(-10)\">Decrease</button>\r\n\r\n\r\n\r\n<h1>Indeterminate</h1>\r\n<div class=\"demo-progress-circle\">\r\n  <md-progress-circle mode=\"indeterminate\"></md-progress-circle>\r\n  <md-progress-circle mode=\"indeterminate\"\r\n                      color=\"accent\"></md-progress-circle>\r\n  <md-spinner></md-spinner>\r\n</div>\r\n"
  },
  {
    "id": "radio",
    "css": ".demo-button {\n  margin: 8px;\n  text-transform: uppercase; }\n\n.demo-section {\n  background-color: #f7f7f7;\n  margin: 8px;\n  padding: 16px; }\n  .demo-section md-radio-button {\n    margin: 8px; }\n",
    "html": "<h1>Basic Example</h1>\r\n<section class=\"demo-section\">\r\n  <md-radio-button name=\"group1\">Option 1</md-radio-button>\r\n  <md-radio-button name=\"group1\">Option 2</md-radio-button>\r\n  <md-radio-button name=\"group1\" disabled=\"true\">Option 3 (disabled)</md-radio-button>\r\n</section>\r\n<h1>Dynamic Example</h1>\r\n<section class=\"demo-section\">\r\n  <div>\r\n    <span>isDisabled: {{isDisabled}}</span>\r\n    <button md-raised-button (click)=\"isDisabled=!isDisabled\" class=\"demo-button\">\r\n      Disable buttons\r\n    </button>\r\n  </div>\r\n  <div>\r\n    <span><md-checkbox [(ngModel)]=\"isAlignEnd\">Align end</md-checkbox></span>\r\n  </div>\r\n  <md-radio-group name=\"my_options\" [disabled]=\"isDisabled\" [align]=\"isAlignEnd ? 'end' : 'start'\">\r\n    <md-radio-button value=\"option_1\">Option 1</md-radio-button>\r\n    <md-radio-button value=\"option_2\">Option 2</md-radio-button>\r\n    <md-radio-button value=\"option_3\">Option 3</md-radio-button>\r\n  </md-radio-group>\r\n</section>\r\n<h1>Favorite Season Example</h1>\r\n<h2>Dynamic Example with two-way data-binding</h2>\r\n<section class=\"demo-section\">\r\n  <md-radio-group name=\"more_options\" [(ngModel)]=\"favoriteSeason\">\r\n    <md-radio-button *ngFor=\"let season of seasonOptions\" name=\"more_options\" [value]=\"season\">\r\n      {{season}}\r\n    </md-radio-button>\r\n  </md-radio-group>\r\n  <p>Your favorite season is: {{favoriteSeason}}</p>\r\n</section>\r\n"
  },
  {
    "id": "ripple",
    "css": ".demo-ripple button, .demo-ripple a {\n  margin: 8px;\n  text-transform: uppercase; }\n\n.demo-ripple .demo-ripple-container {\n  box-shadow: rgba(0, 0, 0, 0.118) 0 10px 15px, rgba(0, 0, 0, 0.239) 0 5px 10px;\n  cursor: pointer;\n  font-size: 24px;\n  height: 150px;\n  line-height: 150px;\n  position: relative;\n  text-align: center;\n  transition: all 200ms linear;\n  width: 200px;\n  user-select: none; }\n  .demo-ripple .demo-ripple-container.demo-ripple-disabled {\n    color: rgba(32, 32, 32, 0.4); }\n  .demo-ripple .demo-ripple-container.demo-ripple-rounded {\n    border-radius: 50%;\n    overflow: hidden;\n    z-index: 1; }\n\n.demo-ripple .demo-ripple-checkbox-option {\n  margin: 10px 0; }\n",
    "html": "<!-- Use <md-card>? -->\r\n<div class=\"demo-ripple\">\r\n  <section>\r\n    <md-checkbox [(ngModel)]=\"disableButtonRipples\">Disable button ripples</md-checkbox>\r\n    <button md-button>flat</button>\r\n    <button md-raised-button>raised</button>\r\n    <button md-fab>\r\n      <md-icon>check</md-icon>\r\n    </button>\r\n    <button md-mini-fab>\r\n      <md-icon>check</md-icon>\r\n    </button>\r\n  </section>\r\n\r\n  <section>\r\n    <div class=\"demo-ripple-checkbox-option\"><md-checkbox [(ngModel)]=\"centered\">Centered</md-checkbox></div>\r\n    <div class=\"demo-ripple-checkbox-option\"><md-checkbox [(ngModel)]=\"unbounded\">Unbounded</md-checkbox></div>\r\n    <div class=\"demo-ripple-checkbox-option\"><md-checkbox [(ngModel)]=\"disabled\">Disabled</md-checkbox></div>\r\n    <div class=\"demo-ripple-checkbox-option\"><md-checkbox [(ngModel)]=\"rounded\">Rounded container (flaky in Firefox)</md-checkbox></div>\r\n  </section>\r\n  <section>\r\n    Speed\r\n    <md-radio-group [(ngModel)]=\"rippleSpeed\">\r\n      <md-radio-button name=\"demo-ripple-options\" value=\"0.1\">Slow</md-radio-button>\r\n      <md-radio-button name=\"demo-ripple-options\" value=\"1\">Normal</md-radio-button>\r\n      <md-radio-button name=\"demo-ripple-options\" value=\"4\">Fast</md-radio-button>\r\n    </md-radio-group>\r\n  </section>\r\n  <section>\r\n    <md-input placeholder=\"Max radius\" aria-label=\"radius\" [(ngModel)]=\"maxRadius\"></md-input>\r\n    <md-input placeholder=\"Ripple color\" aria-label=\"color\" [(ngModel)]=\"rippleColor\"></md-input>\r\n    <md-input placeholder=\"Ripple background\" aria-label=\"background\" [(ngModel)]=\"rippleBackgroundColor\"></md-input>\r\n  </section>\r\n  <section>\r\n    <button md-raised-button (click)=\"doManualRipple()\">Manual ripple</button>\r\n  </section>\r\n  <section>\r\n    <div class=\"demo-ripple-container\"\r\n        [class.demo-ripple-disabled]=\"disabled\"\r\n        [class.demo-ripple-rounded]=\"rounded\"\r\n        md-ripple\r\n        [md-ripple-centered]=\"centered\"\r\n        [md-ripple-disabled]=\"disabled\"\r\n        [md-ripple-unbounded]=\"unbounded\"\r\n        [md-ripple-max-radius]=\"maxRadius\"\r\n        [md-ripple-color]=\"rippleColor\"\r\n        [md-ripple-background-color]=\"rippleBackgroundColor\"\r\n        [md-ripple-speed-factor]=\"rippleSpeed\">\r\n      Click me\r\n    </div>\r\n  </section>\r\n</div>\r\n"
  },
  // {
  //   "id": "select",
  //   "css": "",
  //   "html": "<md-select></md-select>"
  // },
  {
    "id": "sidenav",
    "css": ".demo-sidenav-layout {\n  border: 3px solid black; }\n  .demo-sidenav-layout md-sidenav {\n    padding: 10px; }\n\n.demo-sidenav-content {\n  padding: 15px; }\n",
    "html": "<md-sidenav-layout class=\"demo-sidenav-layout\">\r\n  <md-sidenav #start (open)=\"myinput.focus()\" mode=\"side\">\r\n    Start Side Drawer\r\n    <br>\r\n    <button md-button (click)=\"start.close()\">Close</button>\r\n    <br>\r\n    <button md-button (click)=\"end.open()\">Open End Side</button>\r\n    <br>\r\n    <button md-button\r\n            (click)=\"start.mode = (start.mode == 'push' ? 'over' : (start.mode == 'over' ? 'side' : 'push'))\">Toggle Mode</button>\r\n    <div>Mode: {{start.mode}}</div>\r\n    <br>\r\n    <input #myinput>\r\n  </md-sidenav>\r\n\r\n  <md-sidenav #end align=\"end\">\r\n    End Side Drawer\r\n    <br>\r\n    <button md-button (click)=\"end.close()\">Close</button>\r\n  </md-sidenav>\r\n\r\n  <div class=\"demo-sidenav-content\">\r\n    <h1>My Content</h1>\r\n\r\n    <div>\r\n      <header>Sidenav</header>\r\n      <button md-button (click)=\"start.toggle()\">Toggle Start Side Drawer</button>\r\n      <button md-button (click)=\"end.toggle()\">Toggle End Side Drawer</button>\r\n    </div>\r\n\r\n    <button md-button>HELLO</button>\r\n    <button md-raised-button class=\"md-primary\">HELLO</button>\r\n    <button md-fab class=\"md-accent\">HI</button>\r\n  </div>\r\n</md-sidenav-layout>\r\n\r\n<h2>Content after Sidenav</h2>\r\n"
  },
  {
    "id": "slide-toggle",
    "css": "",
    "html": "<div>\r\n\r\n  <md-slide-toggle color=\"primary\" [(ngModel)]=\"firstToggle\">\r\n    Default Slide Toggle\r\n  </md-slide-toggle>\r\n\r\n  <md-slide-toggle [(ngModel)]=\"firstToggle\" disabled>\r\n    Disabled Slide Toggle\r\n  </md-slide-toggle>\r\n\r\n  <md-slide-toggle [disabled]=\"firstToggle\">\r\n    Disable Bound\r\n  </md-slide-toggle>\r\n\r\n  <p>Example where the slide toggle is required inside of a form.</p>\r\n\r\n  <form #form=\"ngForm\" (ngSubmit)=\"onFormSubmit()\">\r\n\r\n    <md-slide-toggle name=\"slideToggle\" required ngModel>\r\n      Slide Toggle\r\n    </md-slide-toggle>\r\n\r\n    <p>\r\n      <button md-raised-button type=\"submit\">Submit Form</button>\r\n    </p>\r\n\r\n  </form>\r\n\r\n</div>"
  },
  // {
  //   "id": "snack-bar",
  //   "css": ".demo-button-label-input {\n  display: inline-block; }\n",
  //   "html": "<h1>SnackBar demo</h1>\r\n<div>\r\n  <div>Message: <md-input type=\"text\" [(ngModel)]=\"message\"></md-input></div>\r\n  <div>\r\n    <md-checkbox [(ngModel)]=\"action\">\r\n      <p *ngIf=\"!action\">Show button on snack bar</p>\r\n      <md-input type=\"text\" class=\"demo-button-label-input\"\r\n                *ngIf=\"action\"\r\n                placeholder=\"Snack bar action label\"\r\n                [(ngModel)]=\"actionButtonLabel\"></md-input>\r\n    </md-checkbox>\r\n  </div>\r\n</div>\r\n\r\n<button md-raised-button (click)=\"open()\">OPEN</button>"
  // },
  {
    "id": "toolbar",
    "css": ".demo-toolbar {\n  padding: 6px; }\n  .demo-toolbar .demo-toolbar-icon {\n    padding: 0 14px; }\n  .demo-toolbar .demo-fill-remaining {\n    flex: 1 1 auto; }\n",
    "html": "<div class=\"demo-toolbar\">\r\n\r\n  <p>\r\n    <md-toolbar>\r\n      <md-icon class=\"demo-toolbar-icon\">menu</md-icon>\r\n      <span>Default Toolbar</span>\r\n\r\n      <span class=\"demo-fill-remaining\"></span>\r\n\r\n      <md-icon>code</md-icon>\r\n    </md-toolbar>\r\n  </p>\r\n\r\n  <p>\r\n    <md-toolbar color=\"primary\">\r\n      <md-icon class=\"demo-toolbar-icon\">menu</md-icon>\r\n      <span>Primary Toolbar</span>\r\n\r\n      <span class=\"demo-fill-remaining\"></span>\r\n\r\n      <md-icon>code</md-icon>\r\n    </md-toolbar>\r\n  </p>\r\n\r\n  <p>\r\n    <md-toolbar color=\"accent\">\r\n      <md-icon class=\"demo-toolbar-icon\">menu</md-icon>\r\n      <span>Accent Toolbar</span>\r\n\r\n      <span class=\"demo-fill-remaining\"></span>\r\n\r\n      <md-icon>code</md-icon>\r\n    </md-toolbar>\r\n  </p>\r\n\r\n  <p>\r\n    <md-toolbar color=\"accent\">\r\n      <span>Custom Toolbar</span>\r\n      <md-toolbar-row>\r\n        <span>Second Line</span>\r\n      </md-toolbar-row>\r\n    </md-toolbar>\r\n  </p>\r\n\r\n  <p>\r\n    <md-toolbar color=\"primary\">\r\n      <span>Custom Toolbar</span>\r\n\r\n      <md-toolbar-row>\r\n        <span>Second Line</span>\r\n\r\n        <span class=\"demo-fill-remaining\"></span>\r\n\r\n        <md-icon class=\"demo-toolbar-icon\">verified_user</md-icon>\r\n      </md-toolbar-row>\r\n\r\n      <md-toolbar-row>\r\n        <span>Third Line</span>\r\n\r\n        <span class=\"demo-fill-remaining\"></span>\r\n\r\n        <md-icon class=\"demo-toolbar-icon\">favorite</md-icon>\r\n        <md-icon class=\"demo-toolbar-icon\">delete</md-icon>\r\n      </md-toolbar-row>\r\n    </md-toolbar>\r\n  </p>\r\n\r\n</div>"
  },
  {
    "id": "tooltip",
    "css": ".demo-tooltip .centered {\n  text-align: center; }\n\n.demo-tooltip md-radio-button {\n  display: block; }\n",
    "html": "<div class=\"demo-tooltip\">\r\n  <h1>Tooltip Demo</h1>\r\n  <p class=\"centered\">\r\n    <button\r\n        md-raised-button\r\n        color=\"primary\"\r\n        md-tooltip=\"to see a tooltip\"\r\n        [tooltip-position]=\"position\">\r\n      Mouse over this link\r\n    </button>\r\n  </p>\r\n  <p>\r\n    <md-radio-group [(ngModel)]=\"position\">\r\n      <md-radio-button value=\"below\">Below</md-radio-button>\r\n      <md-radio-button value=\"above\">Above</md-radio-button>\r\n      <md-radio-button value=\"before\">Before</md-radio-button>\r\n      <md-radio-button value=\"after\">After</md-radio-button>\r\n    </md-radio-group>\r\n  </p>\r\n</div>\r\n"
  }
])